#include "main.h"

/////////////////////////////////////////////////////////
// NMI Handler siehe crt0.s Definition
// __critical __interrupt erzeugt ein retn am Ende statt reti

void nmi_vint(void) __critical __interrupt
{
	__asm
		 halt
	__endasm ;
  
}

/////////////////////////////////////////////////////////
// Mode 1 Interruptroutine
// Hier kommt alles an, was von der STI ausgelst wird
// Fallunterscheidungen nur durch Flagauswertung mglich

void int_sti_all(void) __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

/////////////////////////////////////////////////////////
// Handler der Mode 2 Interrupts der STI
// __interrupt erzeugt ein reti am Ende, Register werden gesichert
// __naked verhindert Erzeugung von Code zur Registersicherung auf dem Stack
// und erzeugt kein RETI

// Uart Sendepuffer ist voll, es sind Zeichen da!
void int_sti_receive_buffer_full(void)  __interrupt 
{
	__asm
		 ei
	__endasm ;
}

// Interrupt des Timers A
void int_sti_timer_a(void)  __interrupt 
{
	__asm
		 ei
	__endasm ;
}

// Interrupt des Timers B
void int_sti_timer_b(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

// Interrupt des Timers C
void int_sti_timer_c(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

// Uart Sendepuffer ist leer
void int_sti_transmit_buffer_empty(void)  __interrupt 
{
	__asm
		 ei
	__endasm ;
}

void int_sti_timer_d(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

// Unbenutzte Interrupts, jedoch mssen Funktionen bereitstehen

// AD Wandler Interrupt ber STI
void int_sti_gpi_0(void) __interrupt __naked
{


	__asm
		 ei
		 reti
	__endasm ;
}

void int_sti_gpi_1(void)  __interrupt __naked
{

	__asm
		 ei
		 reti
	__endasm ;
}
void int_sti_gpi_2(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}
void int_sti_gpi_3(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

void int_sti_gpi_4(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

void int_sti_gpi_5(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}
 
void int_sti_gpi_6(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}

void int_sti_gpi_7(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}


void int_sti_transmit_error(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}


void int_sti_receive_error(void)  __interrupt __naked
{
	__asm
		 ei
		 reti
	__endasm ;
}






